# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib
# Was set to bcond_with when javadoc plugin was not working
%bcond_without javadoc

%define repodir %{_javadir}/repository.jboss.com/sun-jaxb/%{version_full}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define apiver 2.1
%define version_full %{version}.patch01

Name:           glassfish-jaxb
Version:        2.1.12
Release:        9%{?dist}
Epoch:          0
Summary:        Java API for XML Web Services API
License:        CDDL/GPLv2
Group:          Development/Libraries/Java
URL:            https://jax-ws-sources.dev.java.net/
# cvs -d:pserver:guest@cvs.dev.java.net:/cvs export -r jaxb-2_1_12 -d glassfish-jaxb-2.1.12 jaxb2-sources/jaxb-ri
# tar cjf glassfish-jaxb-2.1.12-src.tar.bz2 glassfish-jaxb-2.1.12
Source0:        glassfish-jaxb-2.1.12-src.tar.bz2
Source2:        %{name}-component-info.xml
Source3:        com-sun-xml-bind-component-info.xml
Source4:	http://repository.jboss.com/maven2/javax/xml/bind/jaxb-api/2.1/jaxb-api-2.1.pom
Source5:	http://repository.jboss.com/maven2/com/sun/xml/bind/jaxb-impl/2.1.12/jaxb-impl-2.1.12.pom
Source6:	http://repository.jboss.com/maven2/com/sun/xml/bind/jaxb-xjc/2.1.12/jaxb-xjc-2.1.12.pom
Patch1:         glassfish-jaxb-2.1.9-JBAS-6535.patch
Patch2:         glassfish-jaxb-JBPAPP-1956.patch
Patch4:         glassfish-jaxb-JBPAPP-2114.patch
Patch5:         glassfish-jaxb-JBPAPP-2121.patch
# FIXME: The pom files below are no longer included in src tar ball, added as
# SourceX
#Patch6:         glassfish-jaxb-pom.patch
# To initialize AbstractDoclet configuration
Patch7:         glassfish-jaxb-abstractdoclet-config.patch
Provides:       jaxb_api = 0:%{apiver}
Provides:       jaxb_2_1_api = 0:%{version}-%{release}
Requires:       glassfish-jaf
Requires:       codehaus-stax11-api
Requires(post): jpackage-utils
Requires(post): %{_sbindir}/update-alternatives
Requires(postun): jpackage-utils
Requires(preun): %{_sbindir}/update-alternatives
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  glassfish-jaf
BuildRequires:  codehaus-stax11-api
BuildRequires:  jboss-parent
BuildRequires:  maven-buildmagic-thirdparty-plugin
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Java Architecture for XML Binding (JAXB) 2.1 API
according to JSR-222 MR1.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%if %with javadoc
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Provides:       jaxb-javadoc = 0:%{apiver}

%description javadoc
%{summary}.
%endif

%prep
%setup -q
/bin/echo FIXME: bundled jars
%{_bindir}/find -name "*.jar" | %{_bindir}/xargs -t /bin/echo
%patch1 -p1
%patch2 -p1
%patch4 -p1 -b .sav4
%patch5 -p1 -b .sav5
# FIXME: The pom files below are no longer in this location
#%%patch6 -p0 -b .sav6
%patch7 -p1 -b .sav7
# FIXME: There is no more CDDL+GPLv2.txt it has been replaced by License.txt
# Not sure if it suffers from the same problem as the old one
#mv CDDL+GPLv2.txt CDDL+GPLv2.txt.orig
#%{_bindir}/iconv -f iso8859-1 -t utf8 -o CDDL+GPLv2.txt CDDL+GPLv2.txt.orig

%build
export CLASSPATH=`pwd`/tools/lib/rebundle/runtime/xsdlib.jar
export OPT_JAR_LIST=:
%{ant} -Dbuild.sysclasspath=first dist
export CLASSPATH=${CLASSPATH}:apgen/build/classes:runtime/build/classes:runtime-deprecated/build/classes:runtime-fi/build/classes:runtime-staxex/build/classes:tools/jing-rnc-driver/build/classes:tools/pretty-printer/build/classes:tools/taglets/build/classes:tools/xmllint/build/classes:xjc/build/classes
%{ant} -Dbuild.sysclasspath=first architecture-document

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
#install -m 644 dist/lib/jaxb-api.jar $RPM_BUILD_ROOT%{_javadir}/jaxb-api.jar
/bin/touch $RPM_BUILD_ROOT%{_javadir}/jaxb-api.jar
#install -m 644 dist/lib/jaxb-api.jar $RPM_BUILD_ROOT%{_javadir}/jaxb_2_1_api.jar
/bin/touch $RPM_BUILD_ROOT%{_javadir}/jaxb_2_1_api.jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -p -m 644 dist/lib/jaxb-api.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/
install -p -m 644 dist/lib/jaxb-impl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/
install -p -m 644 dist/lib/jaxb1-impl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/
install -p -m 644 dist/lib/jaxb-xjc.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

# Commenting the bellow to fix 4.3 build
%if 0
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 jaxb.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

%add_to_maven_depmap javax.xml.bind jaxb-api %{version} JPP %{name}

(cd $RPM_BUILD_ROOT%{_javadir}
ln -s %{name}-%{version}-api.jar jaxb_2_1_api.jar
ln -s %{name}-%{version}-api.jar jaxb_api.jar
ln -sf %{name}-%{version}-api.jar %{name}.jar)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom
%endif

# javadoc
%if %with javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version} || :
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
%endif

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__install} -p -m 644 %{SOURCE4} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jaxb-api.pom
%{__install} -p -m 644 %{SOURCE5} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jaxb-impl.pom
%{__sed} -i "s/@VERSION@/%{version_full}/g" %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jaxb-impl.pom
#%{__install} -p -m 644 tools/poms/jaxb1-impl.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jaxb1-impl.pom
%{__install} -p -m 644 %{SOURCE6} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jaxb-xjc.pom
%{__sed} -i "s/@VERSION@/%{version_full}/g" %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jaxb-xjc.pom
%add_to_maven_depmap com.sun.xml.bind jaxb1-impl %{version} JPP/%{name} jaxb1-impl
%add_to_maven_depmap com.sun.xml.bind jaxb-xjc %{version} JPP/%{name} jaxb-xjc
%add_to_maven_depmap javax.xml.bind jaxb-api %{version} JPP/%{name} jaxb-api
%add_to_maven_depmap com.sun.xml.bind jaxb-impl %{version} JPP/%{name} jaxb-impl
# FIXME: This is for the JBoss proprietary groupId
%add_to_maven_depmap sun-jaxb jaxb1-impl %{version} JPP/%{name} jaxb1-impl
%add_to_maven_depmap sun-jaxb jaxb-xjc %{version} JPP/%{name} jaxb-xjc
%add_to_maven_depmap sun-jaxb jaxb-api %{version} JPP/%{name} jaxb-api
%add_to_maven_depmap sun-jaxb jaxb-impl %{version} JPP/%{name} jaxb-impl

%if %with repolib
%{__install} -d -m 755 %{buildroot}%{repodir}
%{__install} -d -m 755 %{buildroot}%{repodirlib}
%{__install} -p -m 644 %{SOURCE2} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{version_full}-brew/g" %{buildroot}%{repodir}/component-info.xml
%{__install} -d -m 755 %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH1} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH2} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH4} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH5} %{buildroot}%{repodirsrc}
#%{__install} -p -m 644 %{PATCH6} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH7} %{buildroot}%{repodirsrc}
%{__cp} -p dist/lib/jaxb-api.jar %{buildroot}%{repodirlib}/jaxb-api.jar
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jaxb-api.pom %{buildroot}%{repodirlib}/jaxb-api.pom
%{__cp} -p dist/lib/jaxb-impl.jar %{buildroot}%{repodirlib}/jaxb-impl.jar
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jaxb-impl.pom %{buildroot}%{repodirlib}/jaxb-impl.pom
%{__cp} -p dist/lib/jaxb-xjc.jar %{buildroot}%{repodirlib}/jaxb-xjc.jar
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jaxb-xjc.pom %{buildroot}%{repodirlib}/jaxb-xjc.pom

%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

pushd $RPM_BUILD_ROOT%{repodir}
%{_bindir}/mvn-jpp -e \
        org.jboss.maven.plugins:maven-buildmagic-thirdparty-plugin:maven-deploy\
        -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew 
popd
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%{_sbindir}/update-alternatives --install %{_javadir}/jaxb_2_1_api.jar jaxb_2_1_api %{_javadir}/%{name}/jaxb-api.jar 20112
%{_sbindir}/update-alternatives --install %{_javadir}/jaxb_api.jar jaxb_api %{_javadir}/%{name}/jaxb-api.jar 20112

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove jaxb_2_1_api %{_javadir}/%{name}/jaxb-api.jar
    %{_sbindir}/update-alternatives --remove jaxb_api %{_javadir}/%{name}/jaxb-api.jar
fi

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc License.html License.txt HOWTO-build.txt
%{_javadir}*/%{name}/*.jar
%ghost %{_javadir}*/jaxb_2_1_api.jar
%ghost %{_javadir}*/jaxb-api.jar
%{_datadir}/maven2/poms/JPP.%{name}-jaxb-api.pom
%{_datadir}/maven2/poms/JPP.%{name}-jaxb-impl.pom
#%{_datadir}/maven2/poms/JPP.%{name}-jaxb1-impl.pom
%{_datadir}/maven2/poms/JPP.%{name}-jaxb-xjc.pom
%{_mavendepmapfragdir}/%{name}

%if %with javadoc
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Jan 26 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.1.12-9
- Add patch to initialize AbstractDoclet configuration
- Enable javadoc

* Wed Jan 26 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.1.12-8
- Temporarily remove creation of javadoc sub-package

* Tue Jan 11 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.1.12-7
- Remove javadoc from main package

* Wed Dec 15 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.1.12-6
- Add maven2-brew contents to repolib

* Thu Jul 29 2010 Martha Benitez <mbenitez@redhat.com> 0:2.1.12-5
- Rebuild in 5.1

* Thu Jul 29 2010 David Walluck <dwalluck@redhat.com> 0:2.1.12-4
- change alternatives priority from 20100 to 20112

* Thu Jun 10 2010 David Walluck <dwalluck@redhat.com> 0:2.1.12-3
- add (Build)Requires for jaf and stax for jaxb-api-2.1.pom

* Thu Jun 10 2010 Martha Benitez <mbenitez@redhat.com> 0:2.1.12-2
- Comment patch for pom files since files are now bundled sources.

* Mon May 17 2010 Fernando Nasser <fnasser@redhat.com> 0:2.1.12-1
- Upgrade to 2.1.12
- Add pom.xml files for jaxb-api, jaxb-impl and jaxb-xjc
- Exchange CDDL+GPLv2.* files for License.*

* Wed May 05 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.1.9-6.9.1
- rebuilt

* Fri Apr 02 2010 Yong Yang <yyang@redhat.com> 0:2.1.9-6.9
- Rebuild

* Tue Jan 26 2010 David Walluck <dwalluck@redhat.com> 0:2.1.9-6.8
- use sun-jaxb as groupId for all artifacts

* Mon Jan 25 2010 David Walluck <dwalluck@redhat.com> 0:2.1.9-6.7
- add patch to update poms

* Mon Jan 25 2010 David Walluck <dwalluck@redhat.com> 0:2.1.9-6.6
- fix api, impl, and stax versions in the poms
- jaxb-api Provides should use the API version
- add Requires for %%{_sbindir}/update-alternatives

* Thu Jan 14 2010 Martha Benitez <mbenitez@redhat.com> 0:2.1.9-6.5
- Add patch for JIRA issue JBPAPP-3389 JBossWS / JAXB - Mixed up namespace prefixes when marshalling response with Element containing attributes
- Add patch from JBPAPP-2114/2161 JBossWS - Incorrect Parsing of Badly Formed int
- Add patch from JBPAPP-2121/2162 Sun JAXB Accepts Message Despite Failure During Parsing
- Define repolibver to automatically handle version of patches where needed
- Move POMs from repodirsrc to repodirlib

* Thu Dec 10 2009 Fernando Nasser <fnasser@redhat.com> 0:2.1.9-6.4
- Fix POM filenames
- Install POMs in repolib

* Mon Aug 10 2009 David Walluck <dwalluck@redhat.com> 0:2.1.9-6.3
- copy patches to both repolibs

* Mon Aug 10 2009 David Walluck <dwalluck@redhat.com> 0:2.1.9-6.2
- add patches to repolib

* Tue Jul 14 2009 Yong Yang <yyang@redhat.com> 0:2.1.9-6.1
- Merge with JPP-6 2.1.9-6
- Retain patches for JBAS-6535 and JBPAPP-1956

* Fri Jul 10 2009 Martha Benitez <mbenitez@redhat.com> 0:2.1.9-1.3
- Add poms for jaxb-impl and jaxb-xjc to repository

* Thu Jun 18 2009 Permaine Cheung <pcheung@redhat.com> 0:2.1.9-1.2
- Add patch for JBPAPP-1956
- Update repodir location

* Wed Apr 08 2009 Permaine Cheung <pcheung@redhat.com> 0:2.1.9-1.1
- Merge with upstream
- Add patch for JBAS-6535

* Tue Feb 02 2009 David Walluck <dwalluck@redhat.com> 0:2.1.9-1
- 2.1.9
- change jar location from sun-jaxb to %%{name}
- License is CDDL and GPLv2

* Thu Jan 08 2009 Permaine Cheung <pcheung@redhat.com> 0:2.1.4-1.5.ep1
- Added patch for JBPAPP-1560
- Added .patch01 to the repolib location
- Quiet setup

* Tue Aug 05 2008 David Walluck <dwalluck@redhat.com> 0:2.1.4-1jpp.ep1.4
- add xsdlib.jar to CLASSPATH

* Thu Jul 31 2008 Fernando nasser <fnasser@redhat.com> - 0:2.1.4-1jpp.ep1.3
- Plain rebuild

* Fri Jul 18 2008 Clive Saldanha <csaldanh@redhat.com> - 0:2.1.4-1jpp.ep1.2
- Adding all jars to main package

* Fri Jul 18 2008 Clive Saldanha <csaldanh@redhat.com> - 0:2.1.4-1jpp.ep1.1
- First Release
